#!/usr/bin/python3
import random
import sys

# Some lines of equal length in an otherwise random grid.

random.seed(int(sys.argv[1]))

m, n = 1000, 1000

while m*n > 250000:
    m, n = [random.randint(400,600) for _ in range(2)]

k = random.randint(100,300)
print(f'{m} {n} {k}')

grid = [[-1] * n for _ in range(m)]

def ok(x, y):
    return 0 <= x and x < m and 0 <= y and y < m

for _ in range(10):
    dx, dy = random.choice([[0,1], [1,-1], [1,0], [1,1]])
    
    sx = random.randint(0,m-1-(k-1)*abs(dx))
    sy = random.randint(0,n-1-(k-1)*abs(dy))
    if dy < 0: sy += k-1
    
    player = random.randint(0,1)
    for i in range(k):
        grid[sx+i*dx][sy+i*dy] = player

count = [(m*n+1)//2, (m*n)//2]
for x in range(m):
    for y in range(n):
        if grid[x][y] >= 0:
            count[grid[x][y]] -= 1

tiles = [0] * count[0] + [1] * count[1]
random.shuffle(tiles)

p = 0
for x in range(m):
    for y in range(n):
        if grid[x][y] == -1:
            grid[x][y] = tiles[p]
            p += 1

pos = [0] * n
moves = [0] * (m*n)

for i in range(m*n):
    y = random.randint(0,n-1)
    u = 0
    while pos[y] == m or grid[pos[y]][y] != i%2:
        y = random.randint(0,n-1)
        u += 1
        if u > 10000 and pos[y] < m: break
    
    pos[y] += 1
    moves[i] = y+1

print(' '.join(map(str, moves)))
