import Data.Array
import Data.List
import Diagrams.Prelude
import Diagrams.Backend.SVG.CmdLine

board :: [[Colour Double]] -> Diagram B
board tiles =
       vsep 1 [ hsep 1 [circle 1 # fc col | col <- row] | row <- tiles] # center
    <> roundedRect (3*width) (3*height) 0.5 # fc blue
  where
    height = genericLength tiles
    width = genericLength (head tiles)

afterK :: Int -> [[Int]] -> Diagram B
afterK k moves = board $ map (map tileCol) moves
  where
    tileCol i = if i > k then white else if odd i then red else yellow

sampleCase :: [[Int]]
sampleCase = [[9,10,12], [8,7,11], [2,6,5], [1,3,4]]

sampleIllustration :: Diagram B
sampleIllustration = hsep 2 [afterK k sampleCase | k <- [0,3,8,12]]

main :: IO ()
main = mainWith $ frame 1 sampleIllustration
