#include <iostream>
#include <vector>
#include <set>
#include <cmath>
using namespace std;
const int INF = 1e9;

int checkLine(int h, int w, int k, vector<vector<int>> &board, int x, int y, int dx, int dy)
{
	int res = INF;
	std::multiset<int> time;
	int parity = 0;
	do
	{
		time.insert(board[x][y]);
		parity += board[x][y] % 2 ? 1 : -1;
		int px = x - k * dx; int py = y - k * dy;
		if (px >= 0 && py >= 0 && px < w && py < h)
		{
			time.erase(board[px][py]);
			parity -= board[px][py] % 2 ? 1 : -1;
		}
		if (abs(parity) == k)
			res = min(res,*time.rbegin());
		x += dx; y += dy;
	} while (x >= 0 && x < w && y >= 0 && y < h);
	return res;
}

int main()
{
	int h,w,k; cin >> h >> w >> k;
	vector<vector<int>> board(w);
	for (int i = 1; i <= h*w; ++i)
	{
		int col; cin >> col;
		board[col-1].push_back(i);
	}
	int res = INF;
	for (int i = 0; i < w; ++i)
	{
		res = min(res,checkLine(h,w,k,board,i,0,0,1));
		res = min(res,checkLine(h,w,k,board,i,0,-1,1));
		res = min(res,checkLine(h,w,k,board,i,0,1,1));
	}
	for (int j = 0; j < h; ++j)
	{
		res = min(res,checkLine(h,w,k,board,0,j,1,0));
		res = min(res,checkLine(h,w,k,board,w-1,j,-1,1));
		res = min(res,checkLine(h,w,k,board,0,j,1,1));
	}
	if (res == INF) cout << "D" << endl;
	else if (res % 2) cout << "A " << res << endl;
	else cout << "B " << res << endl;
}
