#include <bits/stdc++.h>
using namespace std;

int window, res;
vector<int> a;

void process_line(int start, int jump, int count) {
	if (count < window) return;

	deque<pair<int,int>> q;
	vector<int> parity(2);

	auto add = [&](int i) {
		int x = a[start + i*jump];
		while (!q.empty() && q.back().second <= x) q.pop_back();
		q.emplace_back(i,x);
		parity[x%2]++;
	};
	auto del = [&](int i) {
		int x = a[start + i*jump];
		if (q.front().first == i) q.pop_front();
		parity[x%2]--;
	};

	for (int i = 0; i < window; i++) {
		add(i);
	}
	for (int i = window; i <= count; i++) {
		if (parity[0]%window == 0) {
			res = min(res, q.front().second);
		}
		if (i == count) break;
		add(i), del(i-window);
	}
}

int main() {
	int h, w;
	cin >> h >> w >> window;

	vector<int> pos(w);
	a.resize(h*w);
	
	for (int k = 0; k < h*w; k++) {
		int j; cin >> j;
		int i = pos[--j]++;
		a[i*w+j] = k;
	}
	
	res = h*w;
	for (int i = 0; i < h; i++) {
		process_line(i*w, 1, w);		
		process_line(i*w, w+1, min(w,h-i));
		process_line((i+1)*w-1, w-1, min(w,h-i));
	}
	for (int j = 0; j < w; j++) {
		process_line(j, w, h);
		process_line(j, w+1, min(h,w-j));
		process_line(j, w-1, min(h,j+1));
	}

	if (res == h*w) cout << "D" << endl;
	else cout << "AB"[res%2] << " " << res+1 << endl;
}
